#!/bin/bash
cat=disk
#path=other/$cat
path=data/disk
mkdir -p $path
rm -rf ${path}/*
tmpf=/tmp/${cat}.txt
tmpf2=/tmp/${cat}2.txt
tmpf3=/tmp/${cat}3.txt
rm -rf $tmpf $tmpf2
/usr/sbin/hwinfo --$cat > /tmp/${cat}.txt

skipflag=0
counter=0

while read line
do
   gotnet=`echo $line | grep '^[0-9][0-9]:'`
   if [ $skipflag = "0" ]; then
       if [ "X$gotnet" != "X" ]; then
           #echo $line
           skipflag=1
           counter=`expr $counter + 1`
       fi
   else
       nextstar=`echo $line | grep '^[0-9][0-9]:'`
       if [ "X$nextstar" = "X" ]; then
           echo "BT-$counter:$line" >> $tmpf2
       else
           if [ "X$gotnet" != "X" ]; then
               skipflag=1
               counter=`expr $counter + 1`
           else
               skipflag=0
           fi
       fi
   fi
done < ${tmpf}
echo $counter
num=0
for obj in `cat $tmpf2 | grep 'Hardware Class:' | awk -F: '{print $1}' | sort | uniq`
do
   #echo $obj
   #cat $tmpf2 | grep ^$obj | sed -r 's/'$obj'/NIC-'${num}'/' >> data/net/obj-${num}.txt
   descnull=`cat $tmpf2 | grep ^${obj}: | grep -e "usb" -e "/class/block/ram" -e "usb-storage"`
   if [ "X$descnull" != "X" ]; then
      continue
   fi
   echo $descnull
   #descnull=`cat $tmpf2 | grep ^$obj | grep -i uvcvideo`
   #if [ "X$descnull" != "X" ]; then
      prefix="HD_"
   #else
   #   continue
   #fi

 
 
   num=`expr $num + 1`
   disk=`cat $tmpf2 | grep ^${obj}: | grep 'Device File: ' | awk -F': ' '{print $2}'`
   echo "${prefix}Device${num}=$disk" >> ${path}/${num}.txt

   dpath=`basename $disk`
   if [ -f /sys/block/${dpath}/device/model ]; then
      tmpstr=`cat /sys/block/${dpath}/device/model`
      echo "${prefix}Model${num}=$tmpstr"
      echo "${prefix}Model${num}=$tmpstr" >> ${path}/${num}.txt
 
   else
      tmpstr=`cat $tmpf2 | grep ^${obj}: | grep ":Model:" | sed -r 's#.*"(.*)".*#\1#'`
      echo "${prefix}Model${num}=$tmpstr"
      echo "${prefix}Model${num}=$tmpstr" >> ${path}/${num}.txt
   fi
   vendor=`cat $tmpf2 | grep ^${obj}: | grep ":Vendor:" | sed -r 's#.*"(.*)".*#\1#' | grep -v "Vendor:"`
   echo "${prefix}Vendor${num}=${vendor}" | tee -a ${path}/${num}.txt
   device=`cat $tmpf2 | grep ^${obj}: | grep ":Device:" |  sed -r 's#.*"(.*)".*#\1#' | grep -v "Device:"`
   echo "${prefix}Device${num}=${device}" | tee -a ${path}/${num}.txt
   echo "${prefix}Name${num}=${vendor}_${device}" | tee -a ${path}/${num}.txt


   tmpstr=`cat $tmpf2 | grep ^${obj}: | grep "Driver Modules:" | sed -r 's#.*"(.*)".*#\1#' | grep -v "Driver:"`
   echo "${prefix}Driver${num}=$tmpstr" | tee -a ${path}/${num}.txt
   drv=$tmpstr
   tmpstr=`cat $tmpf2 | grep ^${obj}: | grep "Revision:" | sed -r 's#.*"(.*)".*#\1#' | grep -v "Revision:"`
   if [ "X$tmpstr" = "X" ]; then
	tmpstr=`cat $tmpf2 | grep ^${obj}: | grep "Revision:" | sed -r 's#.*: (.*)#\1#' | grep -v "Revision:"`
   fi
   echo "${prefix}Revision${num}=$tmpstr" | tee -a ${path}/${num}.txt
   tmpstr=`cat $tmpf2 | grep ^${obj}: | grep "Serial ID:" | sed -r 's#.*"(.*)".*#\1#'  | grep -v "Serial ID:"`
   echo "${prefix}Serial${num}=$tmpstr" | tee -a ${path}/${num}.txt

   size=`cat $tmpf2 | grep ^${obj}: | grep "Capacity:" | awk -F': ' '{print $2}' | grep -v "Capacity:"`
   echo "${prefix}Size${num}=$size" | tee -a ${path}/${num}.txt

   size2=`cat $tmpf2 | grep ^${obj}: | grep "Capacity:" | awk -F': ' '{print $2}' | sed -r 's#(.*) GB.*#\1GB#' | grep -v "Capacity:"`
   echo "${prefix}SSize${num}=$size2" | tee -a ${path}/${num}.txt


   #TEST THIS DISK

    smartctl -a $disk > $tmpf3
    smartstatus=`cat $tmpf3 | grep "SMART support is: Enabled" | awk -F': ' '{print $2}'`
    if [ "X$smartstatus" != "X" ]; then
       echo "HD_Smart${num}=$smartstatus"  | sed -r 's/= /=/' >>  ${path}/${num}.txt
       hddstatus=`cat $tmpf3 | grep "SMART overall-health self-assessment test result" | awk -F': ' '{print $2}'`
       echo "HD_Health${num}=$hddstatus" | sed -r 's/= /=/' >>  ${path}/${num}.txt
       hddfirmver=`cat $tmpf3 | grep "Firmware Version:" | awk -F': ' '{print $2}'`
       echo "HD_FirmwareVer${num}=$hddfirmver" | sed -r 's/= /=/' >>  ${path}/${num}.txt
       hddtype=`cat $tmpf3 | grep "Rotation Rate:" | awk -F': ' '{print $2}' | sed -r 's# ##g'`
       echo "HD_Type${num}=$hddtype" | sed -r 's/= /=/' >>  ${path}/${num}.txt
       hddtemp=`cat $tmpf3 | grep 'Temperature_Celsius' | awk '{print $10}'`
       echo "HD_Temp${num}=${hddtemp}" >>  ${path}/${num}.txt

    else
       echo "HD_Smart${num}=None" | sed -r 's/= /=/' >>  ${path}/${num}.txt
    fi

   

done


echo "=============$cat START==============================="
echo "$cat : $num"
#cat $tmpf
echo "================================="
cat ${path}/*.txt
echo "=============$cat END================================="

