#!/bin/bash
cat=gfxcard
#path=other/$cat
path=data/graphic
mkdir -p $path
rm -rf ${path}/*
tmpf=/tmp/${cat}.txt
tmpf2=/tmp/${cat}2.txt
rm -rf $tmpf $tmpf2
/usr/sbin/hwinfo --$cat > /tmp/${cat}.txt

skipflag=0
counter=0

test_vga()
{
    targetfile=$1
    vc_drv=$2
    vc_id=$3
    #TEST THIS VGA
    if [ "X$vc_drv" != "X" ]; then
        dri=`/usr/bin/glxinfo | grep "^direct rendering:" | awk -F: '{print $2}' | grep Yes`
        echo DRI:$dri
        if [ "X${dri}" != "X" ]; then
              echo "VGA_Health${vc_id}=Yes" >> $targetfile
        else
              echo "VGA_Health${vc_id}=No" >> $targetfile
        fi
    fi

}

while read line
do
   gotnet=`echo $line | grep '^[0-9][0-9]:'`
   if [ $skipflag = "0" ]; then
       if [ "X$gotnet" != "X" ]; then
           #echo $line
           skipflag=1
           counter=`expr $counter + 1`
       fi
   else
       nextstar=`echo $line | grep '^[0-9][0-9]:'`
       if [ "X$nextstar" = "X" ]; then
           echo "BT-$counter:$line" >> $tmpf2
       else
           if [ "X$gotnet" != "X" ]; then
               skipflag=1
               counter=`expr $counter + 1`
           else
               skipflag=0
           fi
       fi
   fi
done < ${tmpf}
echo $counter
num=0
for obj in `cat $tmpf2 | grep 'Hardware Class:' | awk -F: '{print $1}' | sort | uniq`
do
   #echo $obj
   #cat $tmpf2 | grep ^$obj | sed -r 's/'$obj'/NIC-'${num}'/' >> data/net/obj-${num}.txt
   descnull=`cat $tmpf2 | grep ^${obj}: | grep "Hardware Class:"`
   if [ "X$descnull" = "X" ]; then
      continue
   fi
   #descnull=`cat $tmpf2 | grep ^$obj | grep -i uvcvideo`
   #if [ "X$descnull" != "X" ]; then
      prefix="VGA_"
   #else
   #   continue
   #fi
 
 
   num=`expr $num + 1`
   tmpstr=`cat $tmpf2 | grep ^$obj | grep ":Model:" | sed -r 's#.*"(.*)".*#\1#'`
   echo "${prefix}Model${num}=$tmpstr"
   echo "${prefix}Model${num}=$tmpstr" >> ${path}/${num}.txt
   echo "${prefix}Name${num}=$tmpstr" >> ${path}/${num}.txt

   tmpstr=`cat $tmpf2 | grep ^$obj | grep ":Vendor:" | sed -r 's#.*0x([0-9a-z]+).*#\1#' | grep -v "Vendor:"`
   echo "${prefix}VendorID${num}=$tmpstr" | tee -a ${path}/${num}.txt
   tmpstr=`cat $tmpf2 | grep ^$obj | grep ":Device:" | sed -r 's#.*0x([0-9a-z]+).*#\1#' | grep -v "Device:"`
   echo "${prefix}DeviceID${num}=$tmpstr" | tee -a ${path}/${num}.txt
   tmpstr=`cat $tmpf2 | grep ^$obj | grep ":Vendor:" | sed -r 's#.*"(.*)".*#\1#' | grep -v ":Vendor:"`

   vidstr=`cat $tmpf2 | grep ^$obj | grep ":Vendor:" | sed -r 's#.*0x([0-9a-z]+).*#\1#' | grep -v "Vendor:"`
   didstr=`cat $tmpf2 | grep ^$obj | grep ":Device:" | sed -r 's#.*0x([0-9a-z]+).*#\1#' | grep -v "Device:"`
   echo "${prefix}ID${num}=${vidstr}:${didstr}" | tee -a ${path}/${num}.txt

   echo "${prefix}Vendor${num}=$tmpstr" | tee -a ${path}/${num}.txt
   tmpstr=`cat $tmpf2 | grep ^$obj | grep ":Device:" |  sed -r 's#.*"(.*)".*#\1#' | grep -v "Device:"`
   echo "${prefix}Device${num}=$tmpstr" | tee -a ${path}/${num}.txt

   tmpstr=`cat $tmpf2 | grep ^$obj | grep ":SubVendor:" | sed -r 's#.*0x([0-9a-z]+).*#\1#' | grep -v "Vendor:"`
   echo "${prefix}SubVendorID${num}=$tmpstr" | tee -a ${path}/${num}.txt
   tmpstr=`cat $tmpf2 | grep ^$obj | grep ":SubDevice:" | sed -r 's#.*0x([0-9a-z]+).*#\1#' | grep -v "Device:"`
   echo "${prefix}SubDeviceID${num}=$tmpstr" | tee -a ${path}/${num}.txt
   tmpstr=`cat $tmpf2 | grep ^$obj | grep ":SubVendor:" | sed -r 's#.*"(.*)".*#\1#' | grep -v ":Vendor:"`
   echo "${prefix}SubVendor${num}=$tmpstr" | tee -a ${path}/${num}.txt
   tmpstr=`cat $tmpf2 | grep ^$obj | grep ":SubDevice:" |  sed -r 's#.*"(.*)".*#\1#' | grep -v "Device:"`
   echo "${prefix}SubDevice${num}=$tmpstr" | tee -a ${path}/${num}.txt


   tmpstr=`cat $tmpf2 | grep ^$obj | grep "Driver:" | sed -r 's#.*"(.*)".*#\1#' | grep -v "Driver:"`
   echo "${prefix}Driver${num}=$tmpstr" | tee -a ${path}/${num}.txt
   drv=$tmpstr
   tmpstr=`cat $tmpf2 | grep ^$obj | grep "Revision:" | sed -r 's#.*"(.*)".*#\1#' | grep -v "Revision:"`
   if [ "X$tmpstr" = "X" ]; then
	tmpstr=`cat $tmpf2 | grep ^$obj | grep "Revision:" | sed -r 's#.*: (.*)#\1#' | grep -v "Revision:"`
   fi
   echo "${prefix}Revision${num}=$tmpstr" | tee -a ${path}/${num}.txt
   tmpstr=`cat $tmpf2 | grep ^$obj | grep "Serial ID:" | sed -r 's#.*"(.*)".*#\1#'  | grep -v "Serial ID:"`
   echo "${prefix}Serial${num}=$tmpstr" | tee -a ${path}/${num}.txt


   #TEST THIS VGA
   echo "test_vga ${path}/1.txt $VGA_Driver1"
   if [ "X$drv" = "X" ]; then
      test_vga ${path}/${num}.txt $drv 1
   else
      test_vga ${path}/${num}.txt 0 1
   fi
   #VGA RAM AMD#########
   if [ "X$vidstr" = "X1002" ]; then
      if [ -x /usr/sbin/radeontop ]; then
          rm -rf /tmp/radeona.txt
          /usr/sbin/radeontop -d /tmp/radeona.txt -l 1
          if [ -f /tmp/radeona.txt ]; then
	      rate=`cat /tmp/radeona.txt | awk -F, '{print $NF}' | sed -r 's#.* ([0-9][0-9].[0-9][0-9])%.*#\1#'`
	      ramuse=`cat /tmp/radeona.txt | awk -F, '{print $NF}' | sed -r 's#.* ([0-9]+.[0-9]+)mb#\1#'`
	      totalram=`awk 'BEGIN{printf "%0.0f\n",('${ramuse}'/'${rate}')*100}'`
   	      echo "${prefix}RAM${num}=$totalram" | tee -a ${path}/${num}.txt
          fi

      fi
   fi
   #####################
   #VGA RAM NVIDIA#########
   if [ "X$vidstr" = "X10de" ]; then
          rm -rf /tmp/nvidia.txt
          #cat /var/log/kern.log | grep nouveau | grep VRAM
	  nvram=`cat /var/log/kern.log | grep nouveau | grep VRAM | awk -F': ' '{print $NF}'`
	  if [ "X$nvram" != "X" ]; then
   	     echo "${prefix}RAM${num}=$nvram" | tee -a ${path}/${num}.txt
	  #else
          #   nvram2=`./nvtop | grep 'total memory' | awk -F': ' '{print $2}'`
          #   if [ "X$nvram2" != "X" ]; then
          #       echo "${prefix}RAM${num}=$nvram2" | tee -a ${path}/${num}.txt
	  #   fi
	  fi
   fi
   #####################
   
   tmpstr="BusID: " 
   tmpstr=`cat $tmpf2 | grep ^$obj | grep "BusID: " | sed -r 's#.* BusID: (.*)#\1#'  | grep -v "BusID:"`
   busid=`cat $tmpf2 | grep ^$obj | grep "BusID: " | sed -r 's#.* BusID: (.*)#\1#'  | grep -v "BusID:" | awk -F: '{print $2}'`
   echo "=====BUSID:[${busid}]"

        if [ "X$busid" = "X00" ]; then
            echo "${prefix}Type${num}=UMA" >> ${path}/${num}.txt
        else
            echo "${prefix}Type${num}=DIS" >> ${path}/${num}.txt
        fi
    #####################
   #VGA RAM UMA#########
   if [ "X$busid" = "X00" ]; then
	  totalram=`/usr/sbin/dmidecode -t memory | grep Size | awk '{a+=$2}END{print a}'`
	  freeram1=`free | grep ^Mem: | awk '{print $2}'`
	  freeram2=`expr $freeram1 / 1024`
	  umaram1=`expr $totalram - $freeram2`
	  if [ $umaram1 -gt 278 ]; then
	      umaram2=`expr $umaram1 - 278`
	      if [ $umaram2 -gt 32 ]; then
                   echo "${prefix}RAM${num}=$umaram2" | tee -a ${path}/${num}.txt
	      fi
          fi
	  echo "TOTAL RAM1:$totalram     ---   FREERAM:$freeram2      --- UMARAM1:$umaram1   --- UMARAM2: $umaram2"
   fi
   #####################



  

done


echo "=============$cat START==============================="
echo "$cat : $num"
#cat $tmpf
echo "================================="
cat ${path}/*.txt
echo "=============$cat END================================="

